import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;

/**  
 *	This plugin closes all open ImageJ windows (except main window), without
 *	asking for confirmation. Options in dialog:
 * 		a) only image windows
 *		b) all windows (image + edit + log + result +...)
 * 
 *  Autor: Wolfgang Konen (konen@gm.fh-koeln.de), 
 *  Version: V1.0, Okt 2006
 */

public class Close_Win implements PlugIn {

	public void run(String arg) {
		boolean im_win=true, all_win=false;
		GenericDialog gd = new GenericDialog("Really close all windows?");
		gd.addCheckbox("Only Image Windows",im_win);
		gd.addCheckbox("All Windows", all_win);
		gd.showDialog();

		if (gd.wasCanceled()) return;

		im_win = gd.getNextBoolean();
		all_win = gd.getNextBoolean();
		ImageWindow iwin = null;
		if (im_win) {
			int n = WindowManager.getWindowCount();
			for (int i=0; i<n; ++i) {
				// does not ask "Save changes?"
				iwin = WindowManager.getCurrentImage().getWindow();
				WindowManager.removeWindow(iwin);
				iwin.setVisible(false);
				iwin.dispose();
			}
		} 
		if (all_win) {
			WindowManager.closeAllWindows();
		}
	}

}
